﻿Public Class Form1
    Friend operation1 As Operation
    Friend roulette1 As Roulette
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        operation1 = New Operation(Me)
        roulette1 = New Roulette(Me)
        Size = New Size(580, 300)
        Text = "すしルーレット"
    End Sub
End Class

Class Roulette
    Private Const FILE_PATH As String = "..\..\"
    Private Const FILE_NAME As String = "Sushi"
    Private Const FILE_TYPE As String = ".GIF"
    Private Const SPEED1 As Integer = 300
    Private Const SPEED2 As Integer = 800
    Private Const INERTIA_MIN As Integer = 2
    Private Const INERTIA_MAX As Integer = 5
    Private Const PICTURE_NO As Integer = 5
    Private picturePoint() As Point = {New Point(104, 12), New Point(196, 40), New Point(196, 133), New Point(104, 170), New Point(12, 133), New Point(12, 40)}
    Private pictureSize As Size = New Size(86, 86)
    Private pb(PICTURE_NO) As PictureBox
    Private count As Integer
    Private inertia As Integer
    Private enclosure As Form1
    Private WithEvents timer1 As Timer
    Sub New(ByVal f As Form1)
        enclosure = f
        For i As Integer = 0 To pb.Length - 1
            pb(i) = New PictureBox
            pb(i).Location = picturePoint(i)
            pb(i).Size = pictureSize
            pb(i).SizeMode = PictureBoxSizeMode.CenterImage
            pb(i).Image = Image.FromFile(FILE_PATH & FILE_NAME & i & FILE_TYPE)
            enclosure.Controls.Add(pb(i))
        Next
        timer1 = New Timer
        inertia = -1
    End Sub
    Sub Rotation()
        timer1.Interval = SPEED1
        timer1.Start()
    End Sub
    Sub RotationStop()
        inertia = New Random().Next(INERTIA_MIN, INERTIA_MAX)
        timer1.Interval = SPEED2
    End Sub
    Private Sub timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles timer1.Tick
        pb(count).BackColor = Color.Yellow
        If count = 0 Then
            pb(PICTURE_NO).BackColor = enclosure.BackColor
        Else
            pb(count - 1).BackColor = enclosure.BackColor
        End If
        count = (count + 1) Mod (PICTURE_NO + 1)
        If inertia > 0 Then
            inertia = inertia - 1
        ElseIf inertia = 0 Then
            inertia = -1
            timer1.Stop()
            enclosure.operation1.GameOver(count)
        End If
    End Sub
End Class

Class Operation
    Private msgLabel As Label
    Private msgLabelPoint As Point = New Point(350, 40)
    Private betButtonPoint() As Point = {New Point(300, 110), New Point(380, 110), New Point(460, 110)}
    Private betButtonSize As Size = New Size(80, 23)
    Private betButtonText() As String = {"うに.いくら", "中トロ・マグロ", "エビ.イカ"}
    Private gameButtonPoint() As Point = {New Point(333, 159), New Point(434, 159)}
    Private gameButtonSize As Size = New Size(70, 23)
    Private gameButtonText() As String = {"スタート", "ストップ"}
    Private betButton(2) As Button
    Private gameButton(1) As Button
    Private betLabel(2) As Label
    Private bet As Integer
    Private enclosure As Form1
    Sub New(ByVal f As Form1)
        enclosure = f
        msgLabel = New Label()
        msgLabel.Location = msgLabelPoint
        msgLabel.AutoSize = True
        msgLabel.Text = "どれに賭けますか？"
        enclosure.Controls.Add(msgLabel)
        For i As Integer = 0 To betButton.Length - 1
            betButton(i) = New Button()
            betButton(i).Location = betButtonPoint(i)
            betButton(i).Size = betButtonSize
            betButton(i).Text = betButtonText(i)
            enclosure.Controls.Add(betButton(i))
            AddHandler betButton(i).Click, AddressOf betButton_Click
        Next
        For i As Integer = 0 To gameButton.Length - 1
            gameButton(i) = New Button()
            gameButton(i).Location = gameButtonPoint(i)
            gameButton(i).Size = gameButtonSize
            gameButton(i).Text = gameButtonText(i)
            gameButton(i).Enabled = False
            enclosure.Controls.Add(gameButton(i))
            AddHandler gameButton(i).Click, AddressOf gameButton_Click
        Next
    End Sub
    Private Sub betButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If sender Is betButton(0) Then
            bet = 0
            msgLabel.Text = "うに・いくらに賭けました！"
        ElseIf sender Is betButton(1) Then
            bet = 1
            msgLabel.Text = "中トロ・マグロに賭けました！"
        ElseIf sender Is betButton(2) Then
            bet = 2
            msgLabel.Text = "エビ・イカに賭けました！"
        End If
        gameButton(0).Enabled = True
    End Sub
    Private Sub gameButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If sender Is gameButton(0) Then
            For Each b As Button In betButton
                b.Enabled = False
            Next
            gameButton(0).Enabled = False
            gameButton(1).Enabled = True
            enclosure.roulette1.Rotation()
        ElseIf sender Is gameButton(1) Then
            gameButton(1).Enabled = False
            enclosure.roulette1.RotationStop()
        End If
    End Sub
    Sub GameOver(ByVal count As Integer)
        If (count = 1 Or count = 2) And bet = 0 Then
            msgLabel.Text = "うに・いくら、当たりました！！"
        ElseIf (count = 4 Or count = 5) And bet = 1 Then
            msgLabel.Text = "中トロ・マグロ、当たりました！！"
        ElseIf (count = 3 Or count = 0) And bet = 2 Then
            msgLabel.Text = "エビ・イカ、当たりました！！"
        Else
            msgLabel.Text = "残念！！どれに賭けますか？"
        End If
        For Each b As Button In betButton
            b.Enabled = True
        Next
    End Sub
End Class
